<?php
namespace App\DataFixtures;

use Doctrine\Bundle\FixturesBundle\Fixture;
use Doctrine\Persistence\ObjectManager;
use Doctrine\Common\DataFixtures\DependentFixtureInterface;
use App\Entity\EventHero;
use App\Entity\Hero;
use App\Entity\Event;

class EventHeroFixtures extends Fixture implements DependentFixtureInterface
{

    public function load(ObjectManager $manager)
    {
        $heroUser1 = $this->getReference(UserFixtures::ADMIN_USER_REFERENCE)->getHeroes()[0];
        $heroUser2 = $this->getReference(UserFixtures::DUDE_USER_REFERENCE)->getHeroes()[0];

        $event1 = $this->getReference(EventFixtures::REF_1);

        $eventHero1 = $this->createEventHero($event1, $heroUser1, 1);
        $manager->persist($eventHero1);

        $eventHero2 = $this->createEventHero($event1, $heroUser2, 2);
        $manager->persist($eventHero2);

        $manager->flush();
    }

    private function createEventHero(Event $event, Hero $hero, int $team)
    {
        return new EventHero($event, $hero, $team);
    }

    public function getDependencies()
    {
        return array(
            UserFixtures::class,
            HeroFixtures::class,
            EventFixtures::class
        );
    }
}

